Subject: [bug#62129] [PATCH] guix: Improve download-nar.

From: Ludovic Courtès <[email-masked]>
Date: Thu, 16 Mar 2023 15:02:52 +0100

Hi Chris,

Christopher Baines <[email-masked]> skribis:

> Previously download-nar worked with gzipped nars and queried
> berlin.guix.gnu.org (also known as ci.guix.gnu.org). ci.guix.gnu.org no longer
> serves gzipped nars so this is of limited use.
>
> This commit changes download-nar to query both the default substitute servers,
> and queries for lzipped rather than gzipped nars, since those are available
> from both.
>
> * guix/build/download-nar.scm (urls-for-item): Return urls for lzip rather
> than gzip compression, and from both default substitute servers. The comment
> about CDN's is no longer relevant.
> (restore-gzipped-nar): Rename to restore-lzipped-nar and reimplement
> accordingly.
> (download-nar): Add progress reporting and switch to use lzip rather than
> gzip.
> * guix/cvs-download.scm (cvs-fetch): Replace guile-zlib with guile-lzlib.
> * guix/git-download.scm (git-fetch): Replace guile-zlib with guile-lzlib.
> * guix/hg-download.scm (hg-fetch): Replace guile-zlib with guile-lzlib.
> * guix/android-repo-download.scm (android-repo-fetch): Add guile-lzlib for
> download-nar

LGTM!

As a second step, we could add support for zstd/gzip (via
guile-{zlib,zstd}) since that comes almost for free due to the fact that
the interface is the same in all three compression libraries.  That will
make it more future-proof.

Thank you,
Ludo’.